package org.beangle.security.monitor.auth.provider.rememberme;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.StringUtils;
import org.beangle.security.monitor.Authentication;
import org.beangle.security.monitor.auth.web.WebUtils;

public class TokenBasedRememberMeServiceImpl implements RememberMeService {

	public RememberMeAuthentication autoLogin(HttpServletRequest httpRequest) {
		String username = WebUtils.getCookieValue(httpRequest, Authentication.NAME);
		if (StringUtils.isNotEmpty(username)) {
			String password = WebUtils.getCookieValue(httpRequest, Authentication.PASSWORD);
			if (StringUtils.isNotEmpty(password)) {
				return new RememberMeAuthentication(username, password);
			}
		}
		return null;
	}
}
