package org.beangle.security.monitor.auth.session.service;

import java.util.List;
import java.util.Map;

import org.beangle.commons.collection.MapUtil;
import org.beangle.model.persist.impl.AbstractBaseDao;
import org.beangle.model.query.builder.OqlBuilder;
import org.beangle.security.UserCategory;
import org.beangle.security.monitor.auth.session.CategoryProfile;
import org.beangle.security.monitor.auth.session.SessionProfile;
import org.beangle.security.monitor.auth.session.SessionProfileProvider;

public class MultiSessionProfileProvider extends AbstractBaseDao implements SessionProfileProvider {

	private Long sessionProfileId;

	public List<CategoryProfile> getProfiles() {
		List<CategoryProfile> profiles = entityDao.loadAll(CategoryProfile.class);
		for (CategoryProfile profile : profiles) {
			profile.setCategory((UserCategory) entityDao.get(UserCategory.class, profile
					.getCategory().getId()));
		}
		return profiles;
	}

	public CategoryProfile getCategoryProfile(UserCategory category) {
		return getProfile().getCategoryProfiles().get(category.getId());
	}

	public SessionProfile getProfile() {
		// read min(id) as needed
		if (null == sessionProfileId) {
			@SuppressWarnings("unchecked")
			List<Long> profileIds = (List<Long>)entityDao.searchHQLQuery("select min(id) from "
					+ SessionProfile.class.getName());
			if (profileIds.isEmpty()) {
				return null;
			} else {
				sessionProfileId = profileIds.get(0);
			}
		}
		SessionProfile profile = (SessionProfile) entityDao.get(SessionProfile.class,
				sessionProfileId);
		// workground for lazy loading
		OqlBuilder<CategoryProfile> builder=OqlBuilder.from(CategoryProfile.class,"cp");
		builder.where("cp.sessionProfile=:profile",profile);
		Map<Long,CategoryProfile> categoryMap=MapUtil.newHashMap();
		for (CategoryProfile categoryProfile: entityDao.search(builder)) {
			UserCategory uc=entityDao.get(UserCategory.class, categoryProfile.getCategory().getId());
			categoryProfile.setCategory(uc);
			categoryMap.put(uc.getId(),categoryProfile);
		}
		profile.setCategoryProfiles(categoryMap);
		return profile;
	}

	public Long getSessionProfileId() {
		return sessionProfileId;
	}

	public void setSessionProfileId(Long sessionProfileId) {
		this.sessionProfileId = sessionProfileId;
	}

}
