package org.beangle.security.monitor.auth.session.service;

import java.util.Date;

import org.beangle.security.monitor.OnlineActivity;
import org.beangle.security.monitor.auth.session.model.OnlineActivityBean;
import org.beangle.security.monitor.auth.ui.UserDetails;
import org.beangle.security.monitor.auth.web.WebUserDetails;

public class OnlineActivityBuilder {

	public static OnlineActivity build(Object principal, Object userDetails, String sessionid,
			Date lastRequest) {
		OnlineActivityBean activity = new OnlineActivityBean();
		activity.setSessionid(sessionid);
		activity.setPrincipal(principal);
		activity.setLastAccessAt(lastRequest);
		UserDetails details = (UserDetails) userDetails;
		activity.setUserid(details.getUserid());
		activity.setFullname(details.getFullname());
		activity.setCategory(details.getCategory());
		if (details instanceof WebUserDetails) {
			activity.setHost(((WebUserDetails) details).getHost());
		}
		activity.setLoginAt(new Date());
		return activity;
	}
}
