package org.beangle.security.monitor.auth.session.service;

import org.beangle.security.monitor.auth.session.CategoryProfile;

public class OnlineProfile {

	private static final long serialVersionUID = 1999239598984221565L;

	private CategoryProfile categoryProfile;

	private transient int online=0;

	public OnlineProfile() {
		super();
	}

	public OnlineProfile(CategoryProfile profile, int initOnline) {
		super();
		this.categoryProfile = profile;
		this.online = initOnline;
	}

	public synchronized boolean reserve() {
		if (online < categoryProfile.getCapacity()) {
			online++;
			return true;
		} else {
			return false;
		}
	}

	public synchronized void left() {
		if (online > 0)
			online--;
	}

	public boolean hasCapacity() {
		return online < categoryProfile.getCapacity();
	}

	public boolean isFull() {
		return !hasCapacity();
	}

	public int getOnline() {
		return online;
	}

	public CategoryProfile getCategoryProfile() {
		return categoryProfile;
	}

	public void setCategoryProfile(CategoryProfile categoryProfile) {
		this.categoryProfile = categoryProfile;
	}

}
