package org.beangle.security.monitor.auth.web;

import java.io.Serializable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.beangle.security.monitor.auth.session.SessionIdentifierAware;
import org.beangle.security.monitor.auth.ui.UserDetails;

public class WebUserDetails extends UserDetails implements SessionIdentifierAware, Serializable {

	private static final long serialVersionUID = -5467873860513829680L;

	public WebUserDetails(HttpServletRequest request) {
		setHost(WebUtils.getIpAddr(request));
		HttpSession session = request.getSession(false);
		setSessionId((session != null) ? session.getId() : null);
		doPopulateAdditionalInformation(request);
	}

	protected void doPopulateAdditionalInformation(HttpServletRequest request) {
	}

	public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append(super.toString() + ": ");
		sb.append("RemoteIpAddress: " + getHost() + "; ");
		sb.append("SessionId: " + getSessionId());
		return sb.toString();
	}
}
