package org.beangle.security.monitor.auth.web;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;

import javax.servlet.http.HttpServletRequest;

import org.beangle.security.monitor.auth.ui.UserDetails;
import org.beangle.security.monitor.auth.ui.UserDetailsSource;
import org.springframework.util.Assert;
import org.springframework.util.ReflectionUtils;

public class WebUserDetailsSource implements UserDetailsSource {

	private Class<?> clazz = WebUserDetails.class;

	public UserDetails buildDetails(Object context) {
		Assert.isInstanceOf(HttpServletRequest.class, context);
		try {
			@SuppressWarnings("unchecked")
			// clazz is must subclass of userDetail,see setClazz
			Constructor constructor = clazz
					.getConstructor(new Class[] { HttpServletRequest.class });
			return (UserDetails) constructor.newInstance(new Object[] { context });
		} catch (NoSuchMethodException ex) {
			ReflectionUtils.handleReflectionException(ex);
		} catch (InvocationTargetException ex) {
			ReflectionUtils.handleReflectionException(ex);
		} catch (InstantiationException ex) {
			ReflectionUtils.handleReflectionException(ex);
		} catch (IllegalAccessException ex) {
			ReflectionUtils.handleReflectionException(ex);
		}
		return null;
	}

	public void setClazz(Class<?> clazz) {
		Assert.notNull(clazz, "Class required");
		if (!UserDetails.class.isAssignableFrom(clazz)) {
			throw new RuntimeException(clazz.getName() + " is not supported");
		}
		this.clazz = clazz;
	}
}
