package org.beangle.security.monitor.impl;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.beangle.security.monitor.Authentication;
import org.beangle.security.monitor.OnlineActivity;
import org.beangle.security.monitor.auth.provider.AbstractAuthenticationListener;
import org.beangle.security.monitor.auth.ui.UserDetails;
import org.beangle.security.monitor.auth.web.ServletRequestAware;

public class HttpSessionListener extends AbstractAuthenticationListener {

	public void afterAuthenticate(Authentication auth) {
		if (auth instanceof ServletRequestAware) {
			HttpServletRequest request = ((ServletRequestAware) auth).getRequest();
			if (null == request) {
				return;
			}
			HttpSession session = request.getSession();
			int min = authenticationManager.getSessionController().getInactiveInterval(
					((UserDetails) auth.getDetails()).getCategory());
			session.setMaxInactiveInterval(min * 60);
			((ServletRequestAware) auth).setRequest(null);
			UserDetails details = (UserDetails) auth.getDetails();
			if (null == details) {
				return;
			}
			session.setAttribute(Authentication.USERID, details.getUserid());
			session.setAttribute(Authentication.LOGINNAME, auth.getPrincipal());
			session.setAttribute(Authentication.FULLNAME, details.getFullname());
			session.setAttribute(Authentication.USER_CATEGORYID, details.getCategory().getId());
			logger.debug(
					"added session attributes USERID,LOGINNAME,USERNAME,USER_CATEGORYID for {}",
					auth.getPrincipal());
		}
	}

	public void afterRemove(OnlineActivity activity) {
		HttpSession session = HttpSessionHolder.getSession();
		if (null == session) {
			return;
		}
		session.removeAttribute(Authentication.USERID);
		session.removeAttribute(Authentication.LOGINNAME);
		session.removeAttribute(Authentication.FULLNAME);
		session.removeAttribute(Authentication.USER_CATEGORYID);
		logger.debug("clean session attribute USERID,LOGINNAME,USERNAME,USER_CATEGORYID");
		HttpSessionHolder.remove();
	}

}
